#
# Conditional build:
%bcond_without	doc	# Documentation
%bcond_without	qm	# QM translations

%define		orgname		qtwebsockets
%define		qtbase_ver		%{version}
%define		qtdeclarative_ver	%{version}
%define		qttools_ver		%{version}
Summary:	The Qt5 WebSockets library
Summary(pl.UTF-8):	Biblioteka Qt5 WebSockets
Name:		qt5-%{orgname}
Version:	5.13.1
Release:	1
License:	LGPL v2.1 with Digia Qt LGPL Exception v1.1 or GPL v3.0
Group:		X11/Libraries
Source0:	http://download.qt.io/official_releases/qt/5.13/%{version}/submodules/%{orgname}-everywhere-src-%{version}.tar.xz
# Source0-md5:	bb19448e678a7a5ed6416225efba69b3
Source1:	http://download.qt.io/official_releases/qt/5.13/%{version}/submodules/qttranslations-everywhere-src-%{version}.tar.xz
# Source1-md5:	8f2e2ce52c296a1bfd814610770663ae
URL:		http://www.qt.io/
BuildRequires:	Qt5Core-devel >= %{qtbase_ver}
BuildRequires:	Qt5Network-devel >= %{qtbase_ver}
BuildRequires:	Qt5Qml-devel >= %{qtdeclarative_ver}
BuildRequires:	Qt5Quick-devel >= %{qtdeclarative_ver}
BuildRequires:	Qt5Sql-devel >= %{qtbase_ver}
%if %{with doc}
BuildRequires:	qt5-assistant >= %{qttools_ver}
%endif
BuildRequires:	qt5-build >= %{qtbase_ver}
%{?with_qm:BuildRequires:	qt5-linguist >= 5.2}
BuildRequires:	qt5-qmake >= %{qtbase_ver}
BuildRequires:	rpmbuild(macros) >= 1.654
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		specflags	-fno-strict-aliasing
%define		qt5dir		%{_libdir}/qt5

%description
Qt is a cross-platform application and UI framework. Using Qt, you can
write web-enabled applications once and deploy them across desktop,
mobile and embedded systems without rewriting the source code.

This package contains Qt5 WebSockets library.

%description -l pl.UTF-8
Qt to wieloplatformowy szkielet aplikacji i interfejsów użytkownika.
Przy użyciu Qt można pisać aplikacje powiązane z WWW i wdrażać je w
systemach biurkowych, przenośnych i wbudowanych bez przepisywania kodu
źródłowego.

Ten pakiet zawiera bibliotekę Qt5 WebSockets.

%package -n Qt5WebSockets
Summary:	The Qt5 WebSockets library
Summary(pl.UTF-8):	Biblioteka Qt5 WebSockets
Group:		Libraries
Requires:	Qt5Core >= %{qtbase_ver}
Requires:	Qt5Network >= %{qtbase_ver}
Requires:	Qt5Sql >= %{qtbase_ver}
Requires:	Qt5Qml >= %{qtdeclarative_ver}

%description -n Qt5WebSockets
Qt5 WebSockets library provides WebSockets communication classes.

%description -n Qt5WebSockets -l pl.UTF-8
Biblioteka Qt5 WebSockets dostarcza klasy do komunikacji przez
WebSockets.

%package -n Qt5WebSockets-devel
Summary:	Qt5 WebSockets library - development files
Summary(pl.UTF-8):	Biblioteka Qt5 WebSockets - pliki programistyczne
Group:		Development/Libraries
Requires:	Qt5Core-devel >= %{qtbase_ver}
Requires:	Qt5Network-devel >= %{qtbase_ver}
Requires:	Qt5Sql-devel >= %{qtbase_ver}
Requires:	Qt5WebSockets = %{version}-%{release}

%description -n Qt5WebSockets-devel
Qt5 WebSockets library - development files.

%description -n Qt5WebSockets-devel -l pl.UTF-8
Biblioteka Qt5 WebSockets - pliki programistyczne.

%package doc
Summary:	Qt5 WebSockets documentation in HTML format
Summary(pl.UTF-8):	Dokumentacja do biblioteki Qt5 WebSockets w formacie HTML
Group:		Documentation
Requires:	qt5-doc-common >= %{qtbase_ver}
%if "%{_rpmversion}" >= "5"
BuildArch:	noarch
%endif

%description doc
Qt5 WebSockets documentation in HTML format.

%description doc -l pl.UTF-8
Dokumentacja do biblioteki Qt5 WebSockets w formacie HTML.

%package doc-qch
Summary:	Qt5 WebSockets documentation in QCH format
Summary(pl.UTF-8):	Dokumentacja do biblioteki Qt5 WebSockets w formacie QCH
Group:		Documentation
Requires:	qt5-doc-common >= %{qtbase_ver}
%if "%{_rpmversion}" >= "5"
BuildArch:	noarch
%endif

%description doc-qch
Qt5 WebSockets documentation in QCH format.

%description doc-qch -l pl.UTF-8
Dokumentacja do biblioteki Qt5 WebSockets w formacie QCH.

%package examples
Summary:	Qt5 WebSockets examples
Summary(pl.UTF-8):	Przykłady do biblioteki Qt5 WebSockets
Group:		X11/Development/Libraries
%if "%{_rpmversion}" >= "5"
BuildArch:	noarch
%endif

%description examples
Qt5 WebSockets examples.

%description examples -l pl.UTF-8
Przykłady do biblioteki Qt5 WebSockets.

%prep
%setup -q -n %{orgname}-everywhere-src-%{version} %{?with_qm:-a1}

%build
qmake-qt5
%{__make}
%{?with_doc:%{__make} docs}

%if %{with qm}
cd qttranslations-everywhere-src-%{version}
qmake-qt5
%{__make}
cd ..
%endif

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	INSTALL_ROOT=$RPM_BUILD_ROOT

%if %{with doc}
%{__make} install_docs \
	INSTALL_ROOT=$RPM_BUILD_ROOT
%endif

%if %{with qm}
%{__make} -C qttranslations-everywhere-src-%{version} install \
	INSTALL_ROOT=$RPM_BUILD_ROOT
# keep only qtwebsockets
%{__rm} $RPM_BUILD_ROOT%{_datadir}/qt5/translations/{assistant,designer,linguist,qt,qtbase,qtconnectivity,qtdeclarative,qtlocation,qtmultimedia,qtquickcontrols,qtquickcontrols2,qtserialport,qtscript,qtwebengine,qtxmlpatterns}_*.qm
%endif

# useless symlinks
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libQt5*.so.5.??
# actually drop *.la, follow policy of not packaging them when *.pc exist
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libQt5*.la

# Prepare some files list
ifecho() {
	r="$RPM_BUILD_ROOT$2"
	if [ -d "$r" ]; then
		echo "%%dir $2" >> $1.files
	elif [ -x "$r" ] ; then
		echo "%%attr(755,root,root) $2" >> $1.files
	elif [ -f "$r" ]; then
		echo "$2" >> $1.files
	else
		echo "Error generation $1 files list!"
		echo "$r: no such file or directory!"
		return 1
	fi
}
ifecho_tree() {
	ifecho $1 $2
	for f in `find $RPM_BUILD_ROOT$2 -printf "%%P "`; do
		ifecho $1 $2/$f
	done
}

echo "%defattr(644,root,root,755)" > examples.files
ifecho_tree examples %{_examplesdir}/qt5/websockets

# find_lang --with-qm supports only PLD qt3/qt4 specific %{_datadir}/locale/*/LC_MESSAGES layout
find_qt5_qm()
{
	name="$1"
	find $RPM_BUILD_ROOT%{_datadir}/qt5/translations -name "${name}_*.qm" | \
		sed -e "s:^$RPM_BUILD_ROOT::" \
		    -e 's:\(.*/'$name'_\)\([a-z][a-z][a-z]\?\)\(_[A-Z][A-Z]\)\?\(\.qm\)$:%lang(\2\3) \1\2\3\4:'
}

echo '%defattr(644,root,root,755)' > qtwebsockets.lang
%if %{with qm}
find_qt5_qm qtwebsockets >> qtwebsockets.lang
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-n Qt5WebSockets -p /sbin/ldconfig
%postun	-n Qt5WebSockets -p /sbin/ldconfig

%files -n Qt5WebSockets -f qtwebsockets.lang
%defattr(644,root,root,755)
%doc README.md
%attr(755,root,root) %{_libdir}/libQt5WebSockets.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libQt5WebSockets.so.5
%dir %{qt5dir}/qml/Qt/WebSockets
%{qt5dir}/qml/Qt/WebSockets/qmldir
%dir %{qt5dir}/qml/QtWebSockets
%attr(755,root,root) %{qt5dir}/qml/QtWebSockets/libdeclarative_qmlwebsockets.so
%{qt5dir}/qml/QtWebSockets/plugins.qmltypes
%{qt5dir}/qml/QtWebSockets/qmldir

%files -n Qt5WebSockets-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libQt5WebSockets.so
%{_libdir}/libQt5WebSockets.prl
%{_includedir}/qt5/QtWebSockets
%{_pkgconfigdir}/Qt5WebSockets.pc
%{_libdir}/cmake/Qt5WebSockets
%{qt5dir}/mkspecs/modules/qt_lib_websockets.pri
%{qt5dir}/mkspecs/modules/qt_lib_websockets_private.pri

%if %{with doc}
%files doc
%defattr(644,root,root,755)
%{_docdir}/qt5-doc/qtwebsockets

%files doc-qch
%defattr(644,root,root,755)
%{_docdir}/qt5-doc/qtwebsockets.qch
%endif

%files examples -f examples.files
%defattr(644,root,root,755)
# XXX: dir shared with qt5-qtbase-examples
%dir %{_examplesdir}/qt5
%changelog
* Fri Oct 18 2019 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/qt5-qtwebsockets.git;a=log;h=master

* Wed Sep 25 2019 Jan Palus <atler@pld-linux.org> 75deed4
- up to 5.13.1

* Wed Jun 19 2019 Jan Palus <atler@pld-linux.org> 09e75cb
- up to 5.13.0

* Sun Apr 21 2019 Jan Palus <atler@pld-linux.org> e37811b
- up to 5.12.3

* Thu Mar 14 2019 Jan Palus <atler@pld-linux.org> c7b4cb2
- up to 5.12.2

* Fri Mar 01 2019 Jan Palus <atler@pld-linux.org> 339101f
- up to 5.12.1

* Sun Aug 12 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 13b981e
- up to 5.11.1

* Tue May 23 2017 Jan Rękorajski <baggins@pld-linux.org> 70084c3
- rename qch bcond to doc (all docs require qtassistant now)

* Tue May 16 2017 Jan Rękorajski <baggins@pld-linux.org> 22b7eef
- up to 5.8.0

* Fri Nov 13 2015 Jakub Bogusz <qboosh@pld-linux.org> 2cb2e89
- updated to 5.5.1
- added translations

* Sat Jun 13 2015 Elan Ruusamäe <glen@delfi.ee> 259ae3e
- up to 5.4.2

* Tue Mar 03 2015 Jan Rękorajski <baggins@pld-linux.org> a29fcc3
- up to 5.4.1

* Sat Oct 18 2014 Jan Rękorajski <baggins@pld-linux.org> 82f0171
- up to 5.3.2

* Sat Jul 05 2014 Jakub Bogusz <qboosh@pld-linux.org> 95ab9f9
- updated to 5.3.1

* Mon Jun 30 2014 Jakub Bogusz <qboosh@pld-linux.org> 1b9ddff
- typo

* Wed Jun 18 2014 Jakub Bogusz <qboosh@pld-linux.org> 90ca793
- new

